@echo off

rem change prefix if using vishnu standalone
set PREFIX=%GSDL3HOME%
rem set PREFIX=..\..

set JAVALIBDIR=%PREFIX%\lib\java
set WEBLIBDIR=%PREFIX%\web\lib
set SERVLETCLASSDIR=%PREFIX%\web\WEB-INF\classes\vishnu\server

rem this is to find the mg stuff when installing as part of Greenstone 3 - 
rem  otherwise the mg jar file should be in the classpath
set MYCLASSPATH=%CLASSPATH%;%PREFIX%\packages\mg\java\org\greenstone\mg\classes

rem the top level src directory
set JAVASRCDIR=..\

rem ---- Where to put class files ----
set JAVACLASSDIR=classes

rem ---- Name and location of java programs ----
set JAVAC=%JAVA_HOME%\bin\javac
set JAVA=%JAVA_HOME%\bin\java
set JAR=%JAVA_HOME%\bin\jar

set JAVACOPTIONS= -deprecation -g -O

if ""%1"" == """" goto compile
if ""%1"" == ""compile"" goto compile
if ""%1"" == ""install"" goto install
if ""%1"" == ""clean"" goto clean
if ""%1"" == ""distclean"" goto distclean

:unknown
	echo Error: Unrecognized argument %1.
	goto done

:compile
        if not exist %JAVACLASSDIR% mkdir %JAVACLASSDIR%
	echo Compiling...
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% builder\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% cluster\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% datablock\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% server\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% server\Search\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\browser\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\dendro\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\object\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\treemap\table\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\treemap\rectangle\*.java
		%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\treemap\visual\*.java
%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\evaluate\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\sammon\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% testvis\visual\*.java
	%JAVAC% -d %JAVACLASSDIR% -sourcepath %JAVASRCDIR% %JAVACOPTIONS% util\*.java

	%JAR% cf vishnu.jar -C %JAVACLASSDIR% vishnu
	goto done

:install
	echo Installing...
	if not exist %JAVALIBDIR% mkdir %JAVALIBDIR%
	if not exist %WEBLIBDIR% mkdir %WEBLIBDIR%
	copy vishnu.jar %JAVALIBDIR%
	copy vishnu.jar %WEBLIBDIR%
	if not exist %SERVLETCLASSDIR% mkdir %SERVLETCLASSDIR%
	copy %JAVACLASSDIR%\vishnu\server\VisServlet.class %SERVLETCLASSDIR%\
	goto done

:clean
:distclean
	echo Cleaning up...
        if exist %JAVACLASSDIR% rmdir /S /Q %JAVACLASSDIR%
	del vishnu.jar
	goto done

:done
